// <auto-generated>
//     Generated by the protocol buffer compiler.  DO NOT EDIT!
//     source: command/security/SignedUpdateFirmware.proto
// </auto-generated>
#pragma warning disable 1591, 0612, 3021, 8981
#region Designer generated code

using pb = global::Google.Protobuf;
using pbc = global::Google.Protobuf.Collections;
using pbr = global::Google.Protobuf.Reflection;
using scg = global::System.Collections.Generic;
namespace SignedUpdateFirmware {

  /// <summary>Holder for reflection information generated from command/security/SignedUpdateFirmware.proto</summary>
  public static partial class SignedUpdateFirmwareReflection {

    #region Descriptor
    /// <summary>File descriptor for command/security/SignedUpdateFirmware.proto</summary>
    public static pbr::FileDescriptor Descriptor {
      get { return descriptor; }
    }
    private static pbr::FileDescriptor descriptor;

    static SignedUpdateFirmwareReflection() {
      byte[] descriptorData = global::System.Convert.FromBase64String(
          string.Concat(
            "Citjb21tYW5kL3NlY3VyaXR5L1NpZ25lZFVwZGF0ZUZpcm13YXJlLnByb3Rv",
            "EhZzaWduZWRfdXBkYXRlX2Zpcm13YXJlGh9nb29nbGUvcHJvdG9idWYvdGlt",
            "ZXN0YW1wLnByb3RvIrQDChtTaWduZWRVcGRhdGVGaXJtd2FyZUNvbW1hbmQS",
            "FAoHcmV0cmllcxgBIAEoBUgAiAEBEhsKDnJldHJ5X2ludGVydmFsGAIgASgF",
            "SAGIAQESEgoKcmVxdWVzdF9pZBgDIAEoBRJSCghmaXJtd2FyZRgEIAEoCzJA",
            "LnNpZ25lZF91cGRhdGVfZmlybXdhcmUuU2lnbmVkVXBkYXRlRmlybXdhcmVD",
            "b21tYW5kLkZpcm13YXJlVHlwZRraAQoMRmlybXdhcmVUeXBlEhAKCGxvY2F0",
            "aW9uGAEgASgJEjYKEnJldHJpZXZlX2RhdGVfdGltZRgCIAEoCzIaLmdvb2ds",
            "ZS5wcm90b2J1Zi5UaW1lc3RhbXASOgoRaW5zdGFsbF9kYXRlX3RpbWUYAyAB",
            "KAsyGi5nb29nbGUucHJvdG9idWYuVGltZXN0YW1wSACIAQESGwoTc2lnbmlu",
            "Z19jZXJ0aWZpY2F0ZRgEIAEoCRIRCglzaWduYXR1cmUYBSABKAlCFAoSX2lu",
            "c3RhbGxfZGF0ZV90aW1lQgoKCF9yZXRyaWVzQhEKD19yZXRyeV9pbnRlcnZh",
            "bCKSAgojU2lnbmVkVXBkYXRlRmlybXdhcmVDb21tYW5kUmVzcG9uc2USaAoG",
            "c3RhdHVzGAEgASgOMlguc2lnbmVkX3VwZGF0ZV9maXJtd2FyZS5TaWduZWRV",
            "cGRhdGVGaXJtd2FyZUNvbW1hbmRSZXNwb25zZS5VcGRhdGVGaXJtd2FyZVN0",
            "YXR1c0VudW1UeXBlIoABChxVcGRhdGVGaXJtd2FyZVN0YXR1c0VudW1UeXBl",
            "EgwKCEFjY2VwdGVkEAASDAoIUmVqZWN0ZWQQARIUChBBY2NlcHRlZENhbmNl",
            "bGVkEAISFgoSSW52YWxpZENlcnRpZmljYXRlEAMSFgoSUmV2b2tlZENlcnRp",
            "ZmljYXRlEARCkgEKIWNvbS5jb2RpYmx5Lm1vZGVsLmNvbW1hbmQuZ2VuZXJp",
            "Y0IZU2lnbmVkVXBkYXRlRmlybXdhcmVQcm90b8oCIURvbWFpbk1vZGVsXFBy",
            "b3RvXENvbW1hbmRcR2VuZXJpY+ICLURvbWFpbk1vZGVsXFByb3RvXENvbW1h",
            "bmRcR2VuZXJpY1xHUEJNZXRhZGF0YWIGcHJvdG8z"));
      descriptor = pbr::FileDescriptor.FromGeneratedCode(descriptorData,
          new pbr::FileDescriptor[] { global::Google.Protobuf.WellKnownTypes.TimestampReflection.Descriptor, },
          new pbr::GeneratedClrTypeInfo(null, null, new pbr::GeneratedClrTypeInfo[] {
            new pbr::GeneratedClrTypeInfo(typeof(global::SignedUpdateFirmware.SignedUpdateFirmwareCommand), global::SignedUpdateFirmware.SignedUpdateFirmwareCommand.Parser, new[]{ "Retries", "RetryInterval", "RequestId", "Firmware" }, new[]{ "Retries", "RetryInterval" }, null, null, new pbr::GeneratedClrTypeInfo[] { new pbr::GeneratedClrTypeInfo(typeof(global::SignedUpdateFirmware.SignedUpdateFirmwareCommand.Types.FirmwareType), global::SignedUpdateFirmware.SignedUpdateFirmwareCommand.Types.FirmwareType.Parser, new[]{ "Location", "RetrieveDateTime", "InstallDateTime", "SigningCertificate", "Signature" }, new[]{ "InstallDateTime" }, null, null, null)}),
            new pbr::GeneratedClrTypeInfo(typeof(global::SignedUpdateFirmware.SignedUpdateFirmwareCommandResponse), global::SignedUpdateFirmware.SignedUpdateFirmwareCommandResponse.Parser, new[]{ "Status" }, null, new[]{ typeof(global::SignedUpdateFirmware.SignedUpdateFirmwareCommandResponse.Types.UpdateFirmwareStatusEnumType) }, null, null)
          }));
    }
    #endregion

  }
  #region Messages
  public sealed partial class SignedUpdateFirmwareCommand : pb::IMessage<SignedUpdateFirmwareCommand>
  #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
      , pb::IBufferMessage
  #endif
  {
    private static readonly pb::MessageParser<SignedUpdateFirmwareCommand> _parser = new pb::MessageParser<SignedUpdateFirmwareCommand>(() => new SignedUpdateFirmwareCommand());
    private pb::UnknownFieldSet _unknownFields;
    private int _hasBits0;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public static pb::MessageParser<SignedUpdateFirmwareCommand> Parser { get { return _parser; } }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public static pbr::MessageDescriptor Descriptor {
      get { return global::SignedUpdateFirmware.SignedUpdateFirmwareReflection.Descriptor.MessageTypes[0]; }
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    pbr::MessageDescriptor pb::IMessage.Descriptor {
      get { return Descriptor; }
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public SignedUpdateFirmwareCommand() {
      OnConstruction();
    }

    partial void OnConstruction();

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public SignedUpdateFirmwareCommand(SignedUpdateFirmwareCommand other) : this() {
      _hasBits0 = other._hasBits0;
      retries_ = other.retries_;
      retryInterval_ = other.retryInterval_;
      requestId_ = other.requestId_;
      firmware_ = other.firmware_ != null ? other.firmware_.Clone() : null;
      _unknownFields = pb::UnknownFieldSet.Clone(other._unknownFields);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public SignedUpdateFirmwareCommand Clone() {
      return new SignedUpdateFirmwareCommand(this);
    }

    /// <summary>Field number for the "retries" field.</summary>
    public const int RetriesFieldNumber = 1;
    private int retries_;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public int Retries {
      get { if ((_hasBits0 & 1) != 0) { return retries_; } else { return 0; } }
      set {
        _hasBits0 |= 1;
        retries_ = value;
      }
    }
    /// <summary>Gets whether the "retries" field is set</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public bool HasRetries {
      get { return (_hasBits0 & 1) != 0; }
    }
    /// <summary>Clears the value of the "retries" field</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void ClearRetries() {
      _hasBits0 &= ~1;
    }

    /// <summary>Field number for the "retry_interval" field.</summary>
    public const int RetryIntervalFieldNumber = 2;
    private int retryInterval_;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public int RetryInterval {
      get { if ((_hasBits0 & 2) != 0) { return retryInterval_; } else { return 0; } }
      set {
        _hasBits0 |= 2;
        retryInterval_ = value;
      }
    }
    /// <summary>Gets whether the "retry_interval" field is set</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public bool HasRetryInterval {
      get { return (_hasBits0 & 2) != 0; }
    }
    /// <summary>Clears the value of the "retry_interval" field</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void ClearRetryInterval() {
      _hasBits0 &= ~2;
    }

    /// <summary>Field number for the "request_id" field.</summary>
    public const int RequestIdFieldNumber = 3;
    private int requestId_;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public int RequestId {
      get { return requestId_; }
      set {
        requestId_ = value;
      }
    }

    /// <summary>Field number for the "firmware" field.</summary>
    public const int FirmwareFieldNumber = 4;
    private global::SignedUpdateFirmware.SignedUpdateFirmwareCommand.Types.FirmwareType firmware_;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public global::SignedUpdateFirmware.SignedUpdateFirmwareCommand.Types.FirmwareType Firmware {
      get { return firmware_; }
      set {
        firmware_ = value;
      }
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public override bool Equals(object other) {
      return Equals(other as SignedUpdateFirmwareCommand);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public bool Equals(SignedUpdateFirmwareCommand other) {
      if (ReferenceEquals(other, null)) {
        return false;
      }
      if (ReferenceEquals(other, this)) {
        return true;
      }
      if (Retries != other.Retries) return false;
      if (RetryInterval != other.RetryInterval) return false;
      if (RequestId != other.RequestId) return false;
      if (!object.Equals(Firmware, other.Firmware)) return false;
      return Equals(_unknownFields, other._unknownFields);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public override int GetHashCode() {
      int hash = 1;
      if (HasRetries) hash ^= Retries.GetHashCode();
      if (HasRetryInterval) hash ^= RetryInterval.GetHashCode();
      if (RequestId != 0) hash ^= RequestId.GetHashCode();
      if (firmware_ != null) hash ^= Firmware.GetHashCode();
      if (_unknownFields != null) {
        hash ^= _unknownFields.GetHashCode();
      }
      return hash;
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public override string ToString() {
      return pb::JsonFormatter.ToDiagnosticString(this);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void WriteTo(pb::CodedOutputStream output) {
    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
      output.WriteRawMessage(this);
    #else
      if (HasRetries) {
        output.WriteRawTag(8);
        output.WriteInt32(Retries);
      }
      if (HasRetryInterval) {
        output.WriteRawTag(16);
        output.WriteInt32(RetryInterval);
      }
      if (RequestId != 0) {
        output.WriteRawTag(24);
        output.WriteInt32(RequestId);
      }
      if (firmware_ != null) {
        output.WriteRawTag(34);
        output.WriteMessage(Firmware);
      }
      if (_unknownFields != null) {
        _unknownFields.WriteTo(output);
      }
    #endif
    }

    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    void pb::IBufferMessage.InternalWriteTo(ref pb::WriteContext output) {
      if (HasRetries) {
        output.WriteRawTag(8);
        output.WriteInt32(Retries);
      }
      if (HasRetryInterval) {
        output.WriteRawTag(16);
        output.WriteInt32(RetryInterval);
      }
      if (RequestId != 0) {
        output.WriteRawTag(24);
        output.WriteInt32(RequestId);
      }
      if (firmware_ != null) {
        output.WriteRawTag(34);
        output.WriteMessage(Firmware);
      }
      if (_unknownFields != null) {
        _unknownFields.WriteTo(ref output);
      }
    }
    #endif

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public int CalculateSize() {
      int size = 0;
      if (HasRetries) {
        size += 1 + pb::CodedOutputStream.ComputeInt32Size(Retries);
      }
      if (HasRetryInterval) {
        size += 1 + pb::CodedOutputStream.ComputeInt32Size(RetryInterval);
      }
      if (RequestId != 0) {
        size += 1 + pb::CodedOutputStream.ComputeInt32Size(RequestId);
      }
      if (firmware_ != null) {
        size += 1 + pb::CodedOutputStream.ComputeMessageSize(Firmware);
      }
      if (_unknownFields != null) {
        size += _unknownFields.CalculateSize();
      }
      return size;
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void MergeFrom(SignedUpdateFirmwareCommand other) {
      if (other == null) {
        return;
      }
      if (other.HasRetries) {
        Retries = other.Retries;
      }
      if (other.HasRetryInterval) {
        RetryInterval = other.RetryInterval;
      }
      if (other.RequestId != 0) {
        RequestId = other.RequestId;
      }
      if (other.firmware_ != null) {
        if (firmware_ == null) {
          Firmware = new global::SignedUpdateFirmware.SignedUpdateFirmwareCommand.Types.FirmwareType();
        }
        Firmware.MergeFrom(other.Firmware);
      }
      _unknownFields = pb::UnknownFieldSet.MergeFrom(_unknownFields, other._unknownFields);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void MergeFrom(pb::CodedInputStream input) {
    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
      input.ReadRawMessage(this);
    #else
      uint tag;
      while ((tag = input.ReadTag()) != 0) {
        switch(tag) {
          default:
            _unknownFields = pb::UnknownFieldSet.MergeFieldFrom(_unknownFields, input);
            break;
          case 8: {
            Retries = input.ReadInt32();
            break;
          }
          case 16: {
            RetryInterval = input.ReadInt32();
            break;
          }
          case 24: {
            RequestId = input.ReadInt32();
            break;
          }
          case 34: {
            if (firmware_ == null) {
              Firmware = new global::SignedUpdateFirmware.SignedUpdateFirmwareCommand.Types.FirmwareType();
            }
            input.ReadMessage(Firmware);
            break;
          }
        }
      }
    #endif
    }

    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    void pb::IBufferMessage.InternalMergeFrom(ref pb::ParseContext input) {
      uint tag;
      while ((tag = input.ReadTag()) != 0) {
        switch(tag) {
          default:
            _unknownFields = pb::UnknownFieldSet.MergeFieldFrom(_unknownFields, ref input);
            break;
          case 8: {
            Retries = input.ReadInt32();
            break;
          }
          case 16: {
            RetryInterval = input.ReadInt32();
            break;
          }
          case 24: {
            RequestId = input.ReadInt32();
            break;
          }
          case 34: {
            if (firmware_ == null) {
              Firmware = new global::SignedUpdateFirmware.SignedUpdateFirmwareCommand.Types.FirmwareType();
            }
            input.ReadMessage(Firmware);
            break;
          }
        }
      }
    }
    #endif

    #region Nested types
    /// <summary>Container for nested types declared in the SignedUpdateFirmwareCommand message type.</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public static partial class Types {
      public sealed partial class FirmwareType : pb::IMessage<FirmwareType>
      #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
          , pb::IBufferMessage
      #endif
      {
        private static readonly pb::MessageParser<FirmwareType> _parser = new pb::MessageParser<FirmwareType>(() => new FirmwareType());
        private pb::UnknownFieldSet _unknownFields;
        [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
        [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
        public static pb::MessageParser<FirmwareType> Parser { get { return _parser; } }

        [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
        [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
        public static pbr::MessageDescriptor Descriptor {
          get { return global::SignedUpdateFirmware.SignedUpdateFirmwareCommand.Descriptor.NestedTypes[0]; }
        }

        [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
        [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
        pbr::MessageDescriptor pb::IMessage.Descriptor {
          get { return Descriptor; }
        }

        [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
        [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
        public FirmwareType() {
          OnConstruction();
        }

        partial void OnConstruction();

        [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
        [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
        public FirmwareType(FirmwareType other) : this() {
          location_ = other.location_;
          retrieveDateTime_ = other.retrieveDateTime_ != null ? other.retrieveDateTime_.Clone() : null;
          installDateTime_ = other.installDateTime_ != null ? other.installDateTime_.Clone() : null;
          signingCertificate_ = other.signingCertificate_;
          signature_ = other.signature_;
          _unknownFields = pb::UnknownFieldSet.Clone(other._unknownFields);
        }

        [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
        [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
        public FirmwareType Clone() {
          return new FirmwareType(this);
        }

        /// <summary>Field number for the "location" field.</summary>
        public const int LocationFieldNumber = 1;
        private string location_ = "";
        [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
        [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
        public string Location {
          get { return location_; }
          set {
            location_ = pb::ProtoPreconditions.CheckNotNull(value, "value");
          }
        }

        /// <summary>Field number for the "retrieve_date_time" field.</summary>
        public const int RetrieveDateTimeFieldNumber = 2;
        private global::Google.Protobuf.WellKnownTypes.Timestamp retrieveDateTime_;
        [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
        [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
        public global::Google.Protobuf.WellKnownTypes.Timestamp RetrieveDateTime {
          get { return retrieveDateTime_; }
          set {
            retrieveDateTime_ = value;
          }
        }

        /// <summary>Field number for the "install_date_time" field.</summary>
        public const int InstallDateTimeFieldNumber = 3;
        private global::Google.Protobuf.WellKnownTypes.Timestamp installDateTime_;
        [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
        [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
        public global::Google.Protobuf.WellKnownTypes.Timestamp InstallDateTime {
          get { return installDateTime_; }
          set {
            installDateTime_ = value;
          }
        }

        /// <summary>Field number for the "signing_certificate" field.</summary>
        public const int SigningCertificateFieldNumber = 4;
        private string signingCertificate_ = "";
        [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
        [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
        public string SigningCertificate {
          get { return signingCertificate_; }
          set {
            signingCertificate_ = pb::ProtoPreconditions.CheckNotNull(value, "value");
          }
        }

        /// <summary>Field number for the "signature" field.</summary>
        public const int SignatureFieldNumber = 5;
        private string signature_ = "";
        [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
        [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
        public string Signature {
          get { return signature_; }
          set {
            signature_ = pb::ProtoPreconditions.CheckNotNull(value, "value");
          }
        }

        [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
        [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
        public override bool Equals(object other) {
          return Equals(other as FirmwareType);
        }

        [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
        [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
        public bool Equals(FirmwareType other) {
          if (ReferenceEquals(other, null)) {
            return false;
          }
          if (ReferenceEquals(other, this)) {
            return true;
          }
          if (Location != other.Location) return false;
          if (!object.Equals(RetrieveDateTime, other.RetrieveDateTime)) return false;
          if (!object.Equals(InstallDateTime, other.InstallDateTime)) return false;
          if (SigningCertificate != other.SigningCertificate) return false;
          if (Signature != other.Signature) return false;
          return Equals(_unknownFields, other._unknownFields);
        }

        [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
        [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
        public override int GetHashCode() {
          int hash = 1;
          if (Location.Length != 0) hash ^= Location.GetHashCode();
          if (retrieveDateTime_ != null) hash ^= RetrieveDateTime.GetHashCode();
          if (installDateTime_ != null) hash ^= InstallDateTime.GetHashCode();
          if (SigningCertificate.Length != 0) hash ^= SigningCertificate.GetHashCode();
          if (Signature.Length != 0) hash ^= Signature.GetHashCode();
          if (_unknownFields != null) {
            hash ^= _unknownFields.GetHashCode();
          }
          return hash;
        }

        [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
        [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
        public override string ToString() {
          return pb::JsonFormatter.ToDiagnosticString(this);
        }

        [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
        [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
        public void WriteTo(pb::CodedOutputStream output) {
        #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
          output.WriteRawMessage(this);
        #else
          if (Location.Length != 0) {
            output.WriteRawTag(10);
            output.WriteString(Location);
          }
          if (retrieveDateTime_ != null) {
            output.WriteRawTag(18);
            output.WriteMessage(RetrieveDateTime);
          }
          if (installDateTime_ != null) {
            output.WriteRawTag(26);
            output.WriteMessage(InstallDateTime);
          }
          if (SigningCertificate.Length != 0) {
            output.WriteRawTag(34);
            output.WriteString(SigningCertificate);
          }
          if (Signature.Length != 0) {
            output.WriteRawTag(42);
            output.WriteString(Signature);
          }
          if (_unknownFields != null) {
            _unknownFields.WriteTo(output);
          }
        #endif
        }

        #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
        [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
        [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
        void pb::IBufferMessage.InternalWriteTo(ref pb::WriteContext output) {
          if (Location.Length != 0) {
            output.WriteRawTag(10);
            output.WriteString(Location);
          }
          if (retrieveDateTime_ != null) {
            output.WriteRawTag(18);
            output.WriteMessage(RetrieveDateTime);
          }
          if (installDateTime_ != null) {
            output.WriteRawTag(26);
            output.WriteMessage(InstallDateTime);
          }
          if (SigningCertificate.Length != 0) {
            output.WriteRawTag(34);
            output.WriteString(SigningCertificate);
          }
          if (Signature.Length != 0) {
            output.WriteRawTag(42);
            output.WriteString(Signature);
          }
          if (_unknownFields != null) {
            _unknownFields.WriteTo(ref output);
          }
        }
        #endif

        [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
        [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
        public int CalculateSize() {
          int size = 0;
          if (Location.Length != 0) {
            size += 1 + pb::CodedOutputStream.ComputeStringSize(Location);
          }
          if (retrieveDateTime_ != null) {
            size += 1 + pb::CodedOutputStream.ComputeMessageSize(RetrieveDateTime);
          }
          if (installDateTime_ != null) {
            size += 1 + pb::CodedOutputStream.ComputeMessageSize(InstallDateTime);
          }
          if (SigningCertificate.Length != 0) {
            size += 1 + pb::CodedOutputStream.ComputeStringSize(SigningCertificate);
          }
          if (Signature.Length != 0) {
            size += 1 + pb::CodedOutputStream.ComputeStringSize(Signature);
          }
          if (_unknownFields != null) {
            size += _unknownFields.CalculateSize();
          }
          return size;
        }

        [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
        [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
        public void MergeFrom(FirmwareType other) {
          if (other == null) {
            return;
          }
          if (other.Location.Length != 0) {
            Location = other.Location;
          }
          if (other.retrieveDateTime_ != null) {
            if (retrieveDateTime_ == null) {
              RetrieveDateTime = new global::Google.Protobuf.WellKnownTypes.Timestamp();
            }
            RetrieveDateTime.MergeFrom(other.RetrieveDateTime);
          }
          if (other.installDateTime_ != null) {
            if (installDateTime_ == null) {
              InstallDateTime = new global::Google.Protobuf.WellKnownTypes.Timestamp();
            }
            InstallDateTime.MergeFrom(other.InstallDateTime);
          }
          if (other.SigningCertificate.Length != 0) {
            SigningCertificate = other.SigningCertificate;
          }
          if (other.Signature.Length != 0) {
            Signature = other.Signature;
          }
          _unknownFields = pb::UnknownFieldSet.MergeFrom(_unknownFields, other._unknownFields);
        }

        [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
        [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
        public void MergeFrom(pb::CodedInputStream input) {
        #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
          input.ReadRawMessage(this);
        #else
          uint tag;
          while ((tag = input.ReadTag()) != 0) {
            switch(tag) {
              default:
                _unknownFields = pb::UnknownFieldSet.MergeFieldFrom(_unknownFields, input);
                break;
              case 10: {
                Location = input.ReadString();
                break;
              }
              case 18: {
                if (retrieveDateTime_ == null) {
                  RetrieveDateTime = new global::Google.Protobuf.WellKnownTypes.Timestamp();
                }
                input.ReadMessage(RetrieveDateTime);
                break;
              }
              case 26: {
                if (installDateTime_ == null) {
                  InstallDateTime = new global::Google.Protobuf.WellKnownTypes.Timestamp();
                }
                input.ReadMessage(InstallDateTime);
                break;
              }
              case 34: {
                SigningCertificate = input.ReadString();
                break;
              }
              case 42: {
                Signature = input.ReadString();
                break;
              }
            }
          }
        #endif
        }

        #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
        [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
        [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
        void pb::IBufferMessage.InternalMergeFrom(ref pb::ParseContext input) {
          uint tag;
          while ((tag = input.ReadTag()) != 0) {
            switch(tag) {
              default:
                _unknownFields = pb::UnknownFieldSet.MergeFieldFrom(_unknownFields, ref input);
                break;
              case 10: {
                Location = input.ReadString();
                break;
              }
              case 18: {
                if (retrieveDateTime_ == null) {
                  RetrieveDateTime = new global::Google.Protobuf.WellKnownTypes.Timestamp();
                }
                input.ReadMessage(RetrieveDateTime);
                break;
              }
              case 26: {
                if (installDateTime_ == null) {
                  InstallDateTime = new global::Google.Protobuf.WellKnownTypes.Timestamp();
                }
                input.ReadMessage(InstallDateTime);
                break;
              }
              case 34: {
                SigningCertificate = input.ReadString();
                break;
              }
              case 42: {
                Signature = input.ReadString();
                break;
              }
            }
          }
        }
        #endif

      }

    }
    #endregion

  }

  public sealed partial class SignedUpdateFirmwareCommandResponse : pb::IMessage<SignedUpdateFirmwareCommandResponse>
  #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
      , pb::IBufferMessage
  #endif
  {
    private static readonly pb::MessageParser<SignedUpdateFirmwareCommandResponse> _parser = new pb::MessageParser<SignedUpdateFirmwareCommandResponse>(() => new SignedUpdateFirmwareCommandResponse());
    private pb::UnknownFieldSet _unknownFields;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public static pb::MessageParser<SignedUpdateFirmwareCommandResponse> Parser { get { return _parser; } }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public static pbr::MessageDescriptor Descriptor {
      get { return global::SignedUpdateFirmware.SignedUpdateFirmwareReflection.Descriptor.MessageTypes[1]; }
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    pbr::MessageDescriptor pb::IMessage.Descriptor {
      get { return Descriptor; }
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public SignedUpdateFirmwareCommandResponse() {
      OnConstruction();
    }

    partial void OnConstruction();

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public SignedUpdateFirmwareCommandResponse(SignedUpdateFirmwareCommandResponse other) : this() {
      status_ = other.status_;
      _unknownFields = pb::UnknownFieldSet.Clone(other._unknownFields);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public SignedUpdateFirmwareCommandResponse Clone() {
      return new SignedUpdateFirmwareCommandResponse(this);
    }

    /// <summary>Field number for the "status" field.</summary>
    public const int StatusFieldNumber = 1;
    private global::SignedUpdateFirmware.SignedUpdateFirmwareCommandResponse.Types.UpdateFirmwareStatusEnumType status_ = global::SignedUpdateFirmware.SignedUpdateFirmwareCommandResponse.Types.UpdateFirmwareStatusEnumType.Accepted;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public global::SignedUpdateFirmware.SignedUpdateFirmwareCommandResponse.Types.UpdateFirmwareStatusEnumType Status {
      get { return status_; }
      set {
        status_ = value;
      }
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public override bool Equals(object other) {
      return Equals(other as SignedUpdateFirmwareCommandResponse);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public bool Equals(SignedUpdateFirmwareCommandResponse other) {
      if (ReferenceEquals(other, null)) {
        return false;
      }
      if (ReferenceEquals(other, this)) {
        return true;
      }
      if (Status != other.Status) return false;
      return Equals(_unknownFields, other._unknownFields);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public override int GetHashCode() {
      int hash = 1;
      if (Status != global::SignedUpdateFirmware.SignedUpdateFirmwareCommandResponse.Types.UpdateFirmwareStatusEnumType.Accepted) hash ^= Status.GetHashCode();
      if (_unknownFields != null) {
        hash ^= _unknownFields.GetHashCode();
      }
      return hash;
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public override string ToString() {
      return pb::JsonFormatter.ToDiagnosticString(this);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void WriteTo(pb::CodedOutputStream output) {
    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
      output.WriteRawMessage(this);
    #else
      if (Status != global::SignedUpdateFirmware.SignedUpdateFirmwareCommandResponse.Types.UpdateFirmwareStatusEnumType.Accepted) {
        output.WriteRawTag(8);
        output.WriteEnum((int) Status);
      }
      if (_unknownFields != null) {
        _unknownFields.WriteTo(output);
      }
    #endif
    }

    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    void pb::IBufferMessage.InternalWriteTo(ref pb::WriteContext output) {
      if (Status != global::SignedUpdateFirmware.SignedUpdateFirmwareCommandResponse.Types.UpdateFirmwareStatusEnumType.Accepted) {
        output.WriteRawTag(8);
        output.WriteEnum((int) Status);
      }
      if (_unknownFields != null) {
        _unknownFields.WriteTo(ref output);
      }
    }
    #endif

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public int CalculateSize() {
      int size = 0;
      if (Status != global::SignedUpdateFirmware.SignedUpdateFirmwareCommandResponse.Types.UpdateFirmwareStatusEnumType.Accepted) {
        size += 1 + pb::CodedOutputStream.ComputeEnumSize((int) Status);
      }
      if (_unknownFields != null) {
        size += _unknownFields.CalculateSize();
      }
      return size;
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void MergeFrom(SignedUpdateFirmwareCommandResponse other) {
      if (other == null) {
        return;
      }
      if (other.Status != global::SignedUpdateFirmware.SignedUpdateFirmwareCommandResponse.Types.UpdateFirmwareStatusEnumType.Accepted) {
        Status = other.Status;
      }
      _unknownFields = pb::UnknownFieldSet.MergeFrom(_unknownFields, other._unknownFields);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void MergeFrom(pb::CodedInputStream input) {
    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
      input.ReadRawMessage(this);
    #else
      uint tag;
      while ((tag = input.ReadTag()) != 0) {
        switch(tag) {
          default:
            _unknownFields = pb::UnknownFieldSet.MergeFieldFrom(_unknownFields, input);
            break;
          case 8: {
            Status = (global::SignedUpdateFirmware.SignedUpdateFirmwareCommandResponse.Types.UpdateFirmwareStatusEnumType) input.ReadEnum();
            break;
          }
        }
      }
    #endif
    }

    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    void pb::IBufferMessage.InternalMergeFrom(ref pb::ParseContext input) {
      uint tag;
      while ((tag = input.ReadTag()) != 0) {
        switch(tag) {
          default:
            _unknownFields = pb::UnknownFieldSet.MergeFieldFrom(_unknownFields, ref input);
            break;
          case 8: {
            Status = (global::SignedUpdateFirmware.SignedUpdateFirmwareCommandResponse.Types.UpdateFirmwareStatusEnumType) input.ReadEnum();
            break;
          }
        }
      }
    }
    #endif

    #region Nested types
    /// <summary>Container for nested types declared in the SignedUpdateFirmwareCommandResponse message type.</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public static partial class Types {
      public enum UpdateFirmwareStatusEnumType {
        [pbr::OriginalName("Accepted")] Accepted = 0,
        [pbr::OriginalName("Rejected")] Rejected = 1,
        [pbr::OriginalName("AcceptedCanceled")] AcceptedCanceled = 2,
        [pbr::OriginalName("InvalidCertificate")] InvalidCertificate = 3,
        [pbr::OriginalName("RevokedCertificate")] RevokedCertificate = 4,
      }

    }
    #endregion

  }

  #endregion

}

#endregion Designer generated code
